# load("C:/Users/wangw/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/NominalD/Stationary24points.RData")
# #load("C:/Users/Wenjia/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/NominalD/Stationary24points.RData")
# XstationaryNominal24=matrix(Result[[2]],ncol=2)
# load("C:/Users/wangw/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/NominalD/Stationary36points.RData")
# #load("C:/Users/Wenjia/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/NominalD/Stationary36points.RData")
# XstationaryNominal36=matrix(Result[[2]],ncol=2)
# load("C:/Users/wangw/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/NominalD/StationarytNpoints.RData")
# #load("C:/Users/Wenjia/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/NominalD/Stationary72points.RData")
# XstationaryNominal72=matrix(Result[[2]],ncol=2)
# load("C:/Users/wangw/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/NominalD/Stationary18points.RData")
# #load("C:/Users/Wenjia/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/NominalD/Stationary18points.RData")
# XstationaryNominal18=matrix(Result[[2]],ncol=2)
# #load("C:/Users/wangw/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/NumericD/numeric18points.RData")
# #load("C:/Users/Wenjia/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/NominalD/numeric18points.RData")
# #XstationaryNumeric=matrix(Result[[2]],ncol=2)
library(mlegp)
library(lhs)
library(mvtnorm)
library(MaxPro)
library(deldir)

tN = 72

# m = 15

# sigmaZ = c(0.05, 0.35, 0.5)
sigmaZ = seq(from = 0.05, to = 0.5, by = 0.05)

mymin = sigmaZ
mymin2 = mymin
myindX = mymin
myindX2 = mymin

NomErrC = matrix(NA,10,0)
avNC = matrix(NA,10,0)

myind = 1

for(sigmaX in sigmaZ){
  
  Theta = diag(c(1,1))
  
  #options(digits = m)
  
  phi = function(dists){
    return(exp(-dists^2))
  }
  
  objfun = function(Xstart)
  {
    X = Xstart
    
    n = n1
    
    sigma = sigmaX^2/(tN/n1)
    
    ThetaX=t(Theta%*%t(X))
    
    temp=deldir(x=ThetaX[,1],y=ThetaX[,2],
                rw=c(0,(Theta%*%matrix(c(1,1)))[1],0,(Theta%*%matrix(c(1,1)))[2]),
                plotit=FALSE)
    
    myConst=100
    myFactor=100
    
    # xttt=X[1:n,1]+X[1:n,2]
    # maxttt=max(xttt)
    # 
    # myMax=max(X)
    # myMin=min(X)
    
    #myDistoptLHSX=as.matrix(dist(rbind(optLHS),diag=TRUE,upper=TRUE))
    #PhiEvalX=phi(myDistoptLHSX)
    #Penalty1=ifelse(myMin<0,(myConst+myFactor*abs(myMin)),0)+ifelse(myMax>1,(myConst+myFactor*(myMax-1)),0)
    
    myPtAndCorners=lapply(tile.list(temp),function(x){
      return(list(pt=x$pt,corners=cbind(x$x,x$y)))
    })
    
    return(max(unlist(lapply(myPtAndCorners,function(x){
      
      A = matrix(rep(x$pt,dim(x$corners)[1]),byrow=TRUE,ncol=2)
      
      return( 2*(phi(0)-(phi(max(sqrt(apply((A-x$corners)^2,1,sum))))))-(1-phi(max(sqrt(apply((A-x$corners)^2,1,sum)))))^2/(n*phi(0)+sigma)+(sigma*(n*phi(0)+2*(1-phi(max(sqrt(apply((A-x$corners)^2,1,sum)))))))/(n*phi(0)+sigma)   )
      
    }))) )
    
  }
  
  avN = matrix(NA,0,1)
  
  NomErr = matrix(NA,0,1)
  
  nums = matrix(NA,0,1)
  
  for(nrun in 3:tN){
    
    if(tN%%nrun == 0){
      
      nums = rbind(nums,nrun)
      
      n1 = nrun
      
      mspes=matrix(NA,0,1)
      
      #method = optLHS, randLHS, rand, maxpro
      ######################################################################
      
      #optLHS=optimumLHS(n1,2)
      #randLHS=randomLHS(n1,2)
      #rand=matrix(runif(n1*2),ncol=2)
      
      # InitialDesign<-MaxProLHD(n = n1, p = 2)$Design
      # DOX<-MaxPro(InitialDesign)
      # maxpro=DOX$Design
       
      ###############################Nominal Upper bound##########################
      
      # NomErr = rbind(NomErr,objfun(maxpro))
      
      mspesNomErr=matrix(NA,0,1)
    
      for(iter in 1:300){
        
        optLHS=optimumLHS(n1,2)
        
        
        # InitialDesign<-MaxProLHD(n = n1, p = 2)$Design
        # DOX<-MaxPro(InitialDesign)
        # maxpro=DOX$Design
        
        testSet=matrix(runif(200*2),ncol=2)
        
        myDistoptLHS=as.matrix(dist(rbind(optLHS,testSet),diag=TRUE,upper=TRUE))
        #myDistrandLHS=as.matrix(dist(rbind(randLHS,testSet),diag=TRUE,upper=TRUE))
        #myDistrand=as.matrix(dist(rbind(rand,testSet),diag=TRUE,upper=TRUE))
        #myDistmaxpro=as.matrix(dist(rbind(maxpro,testSet),diag=TRUE,upper=TRUE))
        
        #PhiEval=phi(myDistmaxpro)
        PhiEval=phi(myDistoptLHS)
        
        GPdraw1 = rmvnorm(n=1,sigma = PhiEval)
        GPdraw = GPdraw1 + rnorm(n=dim(PhiEval)[1])  * sqrt(sigmaX^2/(tN/n1))
        
        fHat = PhiEval[(n1+1):(n1+200),1:n1]%*%solve(PhiEval[1:n1,1:n1] + sigmaX^2/(tN/n1) * diag(n1),GPdraw[1:n1],tol = 0)
        
        a1 = max((fHat-GPdraw1[(n1+1):(n1+200)])^2)
        
        mspes = rbind(mspes, a1)
        
        print(c(myind,iter))
        
        mspesNomErr = rbind(mspesNomErr,objfun(optLHS))
        
      }
      
      avN = rbind(avN,apply(mspes,2,mean)[1])
      NomErr = rbind(NomErr,apply(mspesNomErr,2,mean)[1])
      
    }
  }
  
  NomErrC =  cbind(NomErrC, NomErr)
  avNC =  cbind(avNC, avN)
  
  mymin[myind] = min(NomErr)
  mymin2[myind] = min(avN)
  myindX[myind] = match(min(NomErr),NomErr)
  myindX2[myind] = match(min(avN),avN)
  
  print(myind)
  
  myind = myind + 1
}
save.image(file = "comparisonImageoptLHS3.RData")

# axis(1, at=1:8, labels=nums[3:10])
# 
# plot(1:8,NomErrC[3:10,1],xaxt = "n",ylim = c(0,0.4),type = "l",ylab = "Error",xlab = "Number of Distinct Locations")
# points(1:7,NomErrC[3:9,1])
# text(8,NomErrC[10,1],labels = sigmaZ[1])
# for(i in 2:3){
#   par(new=TRUE)
#   lines(1:8,NomErrC[3:10,i],lty=i)
#   points(1:7,NomErrC[3:9,i])
#   text(8,NomErrC[10,i],labels = sigmaZ[i])
#   # text(locator(), labels = 1:10)
# }
# axis(1, at=1:8, labels=nums[3:10])
# 
# plot(1:8,avNC[3:10,3],xaxt = "n",ylim = c(0,0.3),type = "l",ylab = "Simulated Error",xlab = "Number of Distinct Locations")
# points(1:7,avNC[3:9,3])
# text(8,avNC[10,3],labels = sigmaZ[3])
# for(i in 1:2){
#   par(new=TRUE)
#   lines(1:8,avNC[3:10,i],lty=i)
#   points(1:7,avNC[3:9,i])
#   text(8,avNC[10,i],labels = sigmaZ[i])
#   # text(locator(), labels = 1:10)
# }
# axis(1, at=1:8, labels=nums[3:10])
# 
# 
# plot(1:8,avNC[3:10,3]/NomErrC[3:10,3],xaxt = "n",type = "l",ylab = "Ratio",xlab = "Number of Distinct Locations",ylim=c(0,1.1))
# points(1:7,avNC[3:9,3]/NomErrC[3:9,3])
# text(8,avNC[10,3]/NomErrC[10,3],labels = sigmaZ[3])
# for(i in 1:2){
#   par(new=TRUE)
#   lines(1:8,avNC[3:10,i]/NomErrC[3:10,i],lty=i)
#   points(1:7,avNC[3:9,i]/NomErrC[3:9,i])
#   text(8,avNC[10,i]/NomErrC[10,i],labels = sigmaZ[i])
#   # text(locator(), labels = 1:10)
# }
# axis(1, at=1:8, labels=nums[3:10])
# 
