#load("C:/Users/wangw/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/NominalD/Stationary24points.RData")
load("C:/Users/Wenjia/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/NominalD/Stationary24points.RData")
XstationaryNominal24=matrix(Result[[2]],ncol=2)
#load("C:/Users/wangw/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/NominalD/Stationary36points.RData")
load("C:/Users/Wenjia/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/NominalD/Stationary36points.RData")
XstationaryNominal36=matrix(Result[[2]],ncol=2)
#load("C:/Users/wangw/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/NominalD/Stationary72points.RData")
load("C:/Users/Wenjia/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/NominalD/Stationary72points.RData")
XstationaryNominal72=matrix(Result[[2]],ncol=2)
#load("C:/Users/wangw/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/NominalD/Stationary18points.RData")
load("C:/Users/Wenjia/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/NominalD/Stationary18points.RData")
XstationaryNominal18=matrix(Result[[2]],ncol=2)
#load("C:/Users/wangw/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/NumericD/numeric18points.RData")
#load("C:/Users/Wenjia/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/NominalD/numeric18points.RData")
#XstationaryNumeric=matrix(Result[[2]],ncol=2)
library(mlegp)
library(lhs)
library(mvtnorm)
library(MaxPro)

sigma = sqrt(1)
sigmaX = sigma

phi = function(dists){
  return(exp(-dists^2))
}

mspes18=matrix(NA,0,5)
mspes24=matrix(NA,0,5)
mspes36=matrix(NA,0,5)
mspes72=matrix(NA,0,5)

for(iter in 1:300){
  #maximinLHS(23,2)
  tN = 72
  ################################18######################################
  
  n1 = 18
  optLHS=optimumLHS(n1,2)
  randLHS=randomLHS(n1,2)
  rand=matrix(runif(n1*2),ncol=2)
  
  InitialDesign<-MaxProLHD(n = n1, p = 2)$Design
  DOX<-MaxPro(InitialDesign)
  maxpro=DOX$Design
  
  testSet=matrix(runif(200*2),ncol=2)
  
  myDiststa=as.matrix(dist(rbind(XstationaryNominal18,testSet),diag=TRUE,upper=TRUE))
  myDistoptLHS=as.matrix(dist(rbind(optLHS,testSet),diag=TRUE,upper=TRUE))
  myDistrandLHS=as.matrix(dist(rbind(randLHS,testSet),diag=TRUE,upper=TRUE))
  myDistrand=as.matrix(dist(rbind(rand,testSet),diag=TRUE,upper=TRUE))
  myDistmaxpro=as.matrix(dist(rbind(maxpro,testSet),diag=TRUE,upper=TRUE))
  
  PhiEvalg=phi(myDiststa)
  EigPhiEval=eigen(PhiEvalg)
  
  PhiEval=phi(myDiststa)
  
  # GPdraw=EigPhiEval$vectors%*%diag(sapply(EigPhiEval$values,function(xx){
  #   max(c(xx,0))
  # }))%*%matrix(rnorm(n=dim(PhiEval)[1])) + rnorm(n=dim(PhiEval)[1])  * sqrt(sigma^2/(72/n1))
  
  #GPdraw=rmvnorm(n=1,sigma = PhiEvalg + sigma^2/(72/n1) * diag(dim(PhiEval)[1]))
  
  GPdraw1 = rmvnorm(n=1,sigma = PhiEval)
  GPdraw = GPdraw1 + rnorm(n=dim(PhiEval)[1])  * sqrt(sigmaX^2/(tN/n1))
  
  fHatNom=PhiEval[(n1+1):(n1+100),1:n1]%*%solve(PhiEval[1:n1,1:n1] + sigma^2/(72/n1) * diag(n1),GPdraw[1:n1])
  
  a1 = max((fHatNom-GPdraw1[(n1+1):(n1+100)])^2)
  
  
  PhiEvalg=phi(myDistoptLHS)
  EigPhiEval=eigen(PhiEvalg)
  
  PhiEval=phi(myDistoptLHS)
  
  # GPdraw=EigPhiEval$vectors%*%diag(sapply(EigPhiEval$values,function(xx){
  #   max(c(xx,0))
  # }))%*%matrix(rnorm(n=dim(PhiEval)[1])) + rnorm(n=dim(PhiEval)[1])  * sqrt(sigma^2/(72/n1))
  
  GPdraw1 = rmvnorm(n=1,sigma = PhiEval)
  GPdraw = GPdraw1 + rnorm(n=dim(PhiEval)[1])  * sqrt(sigmaX^2/(tN/n1))
  
  fHatopt=PhiEval[(n1+1):(n1+100),1:n1]%*%solve(PhiEval[1:n1,1:n1] + sigma^2/(72/n1) * diag(n1),GPdraw[1:n1])
  
  a2 = max((fHatopt-GPdraw1[(n1+1):(n1+100)])^2)

  
  PhiEvalg=phi(myDistrandLHS)
  EigPhiEval=eigen(PhiEvalg)
  
  PhiEval=phi(myDistrandLHS)
  
  # GPdraw=EigPhiEval$vectors%*%diag(sapply(EigPhiEval$values,function(xx){
  #   max(c(xx,0))
  # }))%*%matrix(rnorm(n=dim(PhiEval)[1])) + rnorm(n=dim(PhiEval)[1])  * sqrt(sigma^2/(72/n1))
  
  GPdraw1 = rmvnorm(n=1,sigma = PhiEval)
  GPdraw = GPdraw1 + rnorm(n=dim(PhiEval)[1])  * sqrt(sigmaX^2/(tN/n1))
  
  fHatrand=PhiEval[(n1+1):(n1+100),1:n1]%*%solve(PhiEval[1:n1,1:n1] + sigma^2/(72/n1) * diag(n1),GPdraw[1:n1])
  
  a3 = max((fHatrand-GPdraw1[(n1+1):(n1+100)])^2)
  
  PhiEvalg=phi(myDistrand)
  EigPhiEval=eigen(PhiEvalg)
  
  PhiEval=phi(myDistrand)
  
  # GPdraw=EigPhiEval$vectors%*%diag(sapply(EigPhiEval$values,function(xx){
  #   max(c(xx,0))
  # }))%*%matrix(rnorm(n=dim(PhiEval)[1])) + rnorm(n=dim(PhiEval)[1])  * sqrt(sigma^2/(72/n1))
  
  GPdraw1 = rmvnorm(n=1,sigma = PhiEval)
  GPdraw = GPdraw1 + rnorm(n=dim(PhiEval)[1])  * sqrt(sigmaX^2/(tN/n1))
  
  fHatMC=PhiEval[(n1+1):(n1+100),1:n1]%*%solve(PhiEval[1:n1,1:n1] + sigma^2/(72/n1) * diag(n1),GPdraw[1:n1])
  
  a4 = max((fHatMC-GPdraw1[(n1+1):(n1+100)])^2)
  
  
  PhiEvalg=phi(myDistmaxpro)
  EigPhiEval=eigen(PhiEvalg)
  
  PhiEval=phi(myDistmaxpro)
  
  # GPdraw=EigPhiEval$vectors%*%diag(sapply(EigPhiEval$values,function(xx){
  #   max(c(xx,0))
  # }))%*%matrix(rnorm(n=dim(PhiEval)[1])) + rnorm(n=dim(PhiEval)[1])  * sqrt(sigma^2/(72/n1))
  
  GPdraw1 = rmvnorm(n=1,sigma = PhiEval)
  GPdraw = GPdraw1 + rnorm(n=dim(PhiEval)[1])  * sqrt(sigmaX^2/(tN/n1))
  
  fHatmaxpro=PhiEval[(n1+1):(n1+100),1:n1]%*%solve(PhiEval[1:n1,1:n1] + sigma^2/(72/n1) * diag(n1),GPdraw[1:n1])
  
  a5 = max((fHatmaxpro-GPdraw1[(n1+1):(n1+100)])^2)
  
  mspes18 = rbind(mspes18,
              c(a1,a2,a3,a4,a5))
  
  print(1)
  
  ################################24#######################################
  
  n1 = 24
  optLHS=optimumLHS(n1,2)
  randLHS=randomLHS(n1,2)
  rand=matrix(runif(n1*2),ncol=2)
  
  XstationaryNumeric = rand
  
  InitialDesign<-MaxProLHD(n = n1, p = 2)$Design
  DOX<-MaxPro(InitialDesign)
  maxpro=DOX$Design
  
  testSet=matrix(runif(100*2),ncol=2)
  
  myDiststa=as.matrix(dist(rbind(XstationaryNominal24,testSet),diag=TRUE,upper=TRUE))
  myDistoptLHS=as.matrix(dist(rbind(optLHS,testSet),diag=TRUE,upper=TRUE))
  myDistrandLHS=as.matrix(dist(rbind(randLHS,testSet),diag=TRUE,upper=TRUE))
  myDistrand=as.matrix(dist(rbind(rand,testSet),diag=TRUE,upper=TRUE))
  myDistmaxpro=as.matrix(dist(rbind(maxpro,testSet),diag=TRUE,upper=TRUE))
  
  PhiEvalg=phi(myDiststa)
  EigPhiEval=eigen(PhiEvalg)
  
  PhiEval=phi(myDiststa)
  
  # GPdraw=EigPhiEval$vectors%*%diag(sapply(EigPhiEval$values,function(xx){
  #   max(c(xx,0))
  # }))%*%matrix(rnorm(n=dim(PhiEval)[1])) + rnorm(n=dim(PhiEval)[1])  * sqrt(sigma^2/(72/n1))
  
  GPdraw1 = rmvnorm(n=1,sigma = PhiEval)
  GPdraw = GPdraw1 + rnorm(n=dim(PhiEval)[1])  * sqrt(sigmaX^2/(tN/n1))
  
  fHatNom=PhiEval[(n1+1):(n1+100),1:n1]%*%solve(PhiEval[1:n1,1:n1] + sigma^2/(72/n1) * diag(n1),GPdraw[1:n1])
  
  a1 = max((fHatNom-GPdraw1[(n1+1):(n1+100)])^2)
  
  PhiEvalg=phi(myDistoptLHS)
  EigPhiEval=eigen(PhiEvalg)
  
  PhiEval=phi(myDistoptLHS)
  
  # GPdraw=EigPhiEval$vectors%*%diag(sapply(EigPhiEval$values,function(xx){
  #   max(c(xx,0))
  # }))%*%matrix(rnorm(n=dim(PhiEval)[1])) + rnorm(n=dim(PhiEval)[1])  * sqrt(sigma^2/(72/n1))
  
  GPdraw1 = rmvnorm(n=1,sigma = PhiEval)
  GPdraw = GPdraw1 + rnorm(n=dim(PhiEval)[1])  * sqrt(sigmaX^2/(tN/n1))
  
  fHatopt=PhiEval[(n1+1):(n1+100),1:n1]%*%solve(PhiEval[1:n1,1:n1] + sigma^2/(72/n1) * diag(n1),GPdraw[1:n1])
  
  a2 = max((fHatopt-GPdraw1[(n1+1):(n1+100)])^2)
  
  PhiEvalg=phi(myDistrandLHS)
  EigPhiEval=eigen(PhiEvalg)
  
  PhiEval=phi(myDistrandLHS) 
  
  # GPdraw=EigPhiEval$vectors%*%diag(sapply(EigPhiEval$values,function(xx){
  #   max(c(xx,0))
  # }))%*%matrix(rnorm(n=dim(PhiEval)[1])) + rnorm(n=dim(PhiEval)[1])  * sqrt(sigma^2/(72/n1))
  
  GPdraw1 = rmvnorm(n=1,sigma = PhiEval)
  GPdraw = GPdraw1 + rnorm(n=dim(PhiEval)[1])  * sqrt(sigmaX^2/(tN/n1))
  
  fHatrand=PhiEval[(n1+1):(n1+100),1:n1]%*%solve(PhiEval[1:n1,1:n1] + sigma^2/(72/n1) * diag(n1),GPdraw[1:n1])
  
  a3 = max((fHatrand-GPdraw1[(n1+1):(n1+100)])^2)
  
  PhiEvalg=phi(myDistrand)
  EigPhiEval=eigen(PhiEvalg)
  
  PhiEval=phi(myDistrand)
  
  # GPdraw=EigPhiEval$vectors%*%diag(sapply(EigPhiEval$values,function(xx){
  #   max(c(xx,0))
  # }))%*%matrix(rnorm(n=dim(PhiEval)[1])) + rnorm(n=dim(PhiEval)[1])  * sqrt(sigma^2/(72/n1))
  
  GPdraw1 = rmvnorm(n=1,sigma = PhiEval)
  GPdraw = GPdraw1 + rnorm(n=dim(PhiEval)[1])  * sqrt(sigmaX^2/(tN/n1))
  
  fHatMC=PhiEval[(n1+1):(n1+100),1:n1]%*%solve(PhiEval[1:n1,1:n1] + sigma^2/(72/n1) * diag(n1),GPdraw[1:n1])
  
  a4 = max((fHatMC-GPdraw1[(n1+1):(n1+100)])^2)
  
  
  PhiEvalg=phi(myDistmaxpro)
  EigPhiEval=eigen(PhiEvalg)
  
  PhiEval=phi(myDistmaxpro)
  
  # GPdraw=EigPhiEval$vectors%*%diag(sapply(EigPhiEval$values,function(xx){
  #   max(c(xx,0))
  # }))%*%matrix(rnorm(n=dim(PhiEval)[1])) + rnorm(n=dim(PhiEval)[1])  * sqrt(sigma^2/(72/n1))
  
  GPdraw1 = rmvnorm(n=1,sigma = PhiEval)
  GPdraw = GPdraw1 + rnorm(n=dim(PhiEval)[1])  * sqrt(sigmaX^2/(tN/n1))
  
  fHatmaxpro=PhiEval[(n1+1):(n1+100),1:n1]%*%solve(PhiEval[1:n1,1:n1] + sigma^2/(72/n1) * diag(n1),GPdraw[1:n1])
  
  a5 = max((fHatmaxpro-GPdraw1[(n1+1):(n1+100)])^2)
  
  mspes24 = rbind(mspes24,
                  c(a1,a2,a3,a4,a5))
  
  print(2)
  
  ################################36#######################################
  
  n1 = 36
  optLHS=optimumLHS(n1,2)
  randLHS=randomLHS(n1,2)
  rand=matrix(runif(n1*2),ncol=2)
  
  XstationaryNumeric = rand
  
  InitialDesign<-MaxProLHD(n = n1, p = 2)$Design
  DOX<-MaxPro(InitialDesign)
  maxpro=DOX$Design
  
  testSet=matrix(runif(100*2),ncol=2)
  
  myDiststa=as.matrix(dist(rbind(XstationaryNominal36,testSet),diag=TRUE,upper=TRUE))
  myDistoptLHS=as.matrix(dist(rbind(optLHS,testSet),diag=TRUE,upper=TRUE))
  myDistrandLHS=as.matrix(dist(rbind(randLHS,testSet),diag=TRUE,upper=TRUE))
  myDistrand=as.matrix(dist(rbind(rand,testSet),diag=TRUE,upper=TRUE))
  myDistmaxpro=as.matrix(dist(rbind(maxpro,testSet),diag=TRUE,upper=TRUE))
  
  PhiEvalg=phi(myDiststa)
  EigPhiEval=eigen(PhiEvalg)
  
  PhiEval=phi(myDiststa) 
  
  # GPdraw=EigPhiEval$vectors%*%diag(sapply(EigPhiEval$values,function(xx){
  #   max(c(xx,0))
  # }))%*%matrix(rnorm(n=dim(PhiEval)[1])) + rnorm(n=dim(PhiEval)[1])  * sqrt(sigma^2/(72/n1))
  
  GPdraw1 = rmvnorm(n=1,sigma = PhiEval)
  GPdraw = GPdraw1 + rnorm(n=dim(PhiEval)[1])  * sqrt(sigmaX^2/(tN/n1))
  
  fHatNom=PhiEval[(n1+1):(n1+100),1:n1]%*%solve(PhiEval[1:n1,1:n1] + sigma^2/(72/n1) * diag(n1),GPdraw[1:n1])
  
  a1 = max((fHatNom-GPdraw1[(n1+1):(n1+100)])^2)
  
  PhiEvalg=phi(myDistoptLHS)
  EigPhiEval=eigen(PhiEvalg)
  
  PhiEval=phi(myDistoptLHS) 
  
  # GPdraw=EigPhiEval$vectors%*%diag(sapply(EigPhiEval$values,function(xx){
  #   max(c(xx,0))
  # }))%*%matrix(rnorm(n=dim(PhiEval)[1])) + rnorm(n=dim(PhiEval)[1])  * sqrt(sigma^2/(72/n1))
  
  GPdraw1 = rmvnorm(n=1,sigma = PhiEval)
  GPdraw = GPdraw1 + rnorm(n=dim(PhiEval)[1])  * sqrt(sigmaX^2/(tN/n1))
  
  fHatopt=PhiEval[(n1+1):(n1+100),1:n1]%*%solve(PhiEval[1:n1,1:n1] + sigma^2/(72/n1) * diag(n1),GPdraw[1:n1])
  
  a2 = max((fHatopt-GPdraw1[(n1+1):(n1+100)])^2)
  
  PhiEvalg=phi(myDistrandLHS)
  EigPhiEval=eigen(PhiEvalg)
  
  PhiEval=phi(myDistrandLHS) 
  
  # GPdraw=EigPhiEval$vectors%*%diag(sapply(EigPhiEval$values,function(xx){
  #   max(c(xx,0))
  # }))%*%matrix(rnorm(n=dim(PhiEval)[1])) + rnorm(n=dim(PhiEval)[1])  * sqrt(sigma^2/(72/n1))
  
  GPdraw1 = rmvnorm(n=1,sigma = PhiEval)
  GPdraw = GPdraw1 + rnorm(n=dim(PhiEval)[1])  * sqrt(sigmaX^2/(tN/n1))
  
  fHatrand=PhiEval[(n1+1):(n1+100),1:n1]%*%solve(PhiEval[1:n1,1:n1] + sigma^2/(72/n1) * diag(n1),GPdraw[1:n1])
  
  a3 = max((fHatrand-GPdraw1[(n1+1):(n1+100)])^2)
  
  PhiEvalg=phi(myDistrand)
  EigPhiEval=eigen(PhiEvalg)
  
  PhiEval=phi(myDistrand) 
  
  # GPdraw=EigPhiEval$vectors%*%diag(sapply(EigPhiEval$values,function(xx){
  #   max(c(xx,0))
  # }))%*%matrix(rnorm(n=dim(PhiEval)[1])) + rnorm(n=dim(PhiEval)[1])  * sqrt(sigma^2/(72/n1))
  
  GPdraw1 = rmvnorm(n=1,sigma = PhiEval)
  GPdraw = GPdraw1 + rnorm(n=dim(PhiEval)[1])  * sqrt(sigmaX^2/(tN/n1))
  
  fHatMC=PhiEval[(n1+1):(n1+100),1:n1]%*%solve(PhiEval[1:n1,1:n1] + sigma^2/(72/n1) * diag(n1),GPdraw[1:n1])
  
  a4 = max((fHatMC-GPdraw1[(n1+1):(n1+100)])^2)
  
  
  PhiEvalg=phi(myDistmaxpro)
  EigPhiEval=eigen(PhiEvalg)
  
  PhiEval=phi(myDistmaxpro) 
  
  # GPdraw=EigPhiEval$vectors%*%diag(sapply(EigPhiEval$values,function(xx){
  #   max(c(xx,0))
  # }))%*%matrix(rnorm(n=dim(PhiEval)[1])) + rnorm(n=dim(PhiEval)[1])  * sqrt(sigma^2/(72/n1))
  
  GPdraw1 = rmvnorm(n=1,sigma = PhiEval)
  GPdraw = GPdraw1 + rnorm(n=dim(PhiEval)[1])  * sqrt(sigmaX^2/(tN/n1))
  
  fHatmaxpro=PhiEval[(n1+1):(n1+100),1:n1]%*%solve(PhiEval[1:n1,1:n1] + sigma^2/(72/n1) * diag(n1),GPdraw[1:n1])
  
  a5 = max((fHatmaxpro-GPdraw1[(n1+1):(n1+100)])^2)
  
  mspes36 = rbind(mspes36,
                  c(a1,a2,a3,a4,a5))
  print(3)
  
  ################################72#######################################
  
  n1 = 72
  optLHS=optimumLHS(n1,2)
  randLHS=randomLHS(n1,2)
  rand=matrix(runif(n1*2),ncol=2)
  
  XstationaryNumeric = rand
  
  InitialDesign<-MaxProLHD(n = n1, p = 2)$Design
  DOX<-MaxPro(InitialDesign)
  maxpro=DOX$Design
  
  testSet=matrix(runif(100*2),ncol=2)
  
  myDiststa=as.matrix(dist(rbind(XstationaryNominal72,testSet),diag=TRUE,upper=TRUE))
  myDistoptLHS=as.matrix(dist(rbind(optLHS,testSet),diag=TRUE,upper=TRUE))
  myDistrandLHS=as.matrix(dist(rbind(randLHS,testSet),diag=TRUE,upper=TRUE))
  myDistrand=as.matrix(dist(rbind(rand,testSet),diag=TRUE,upper=TRUE))
  myDistmaxpro=as.matrix(dist(rbind(maxpro,testSet),diag=TRUE,upper=TRUE))
  
  PhiEvalg=phi(myDiststa)
  EigPhiEval=eigen(PhiEvalg)
  
  PhiEval=phi(myDiststa) 
  
  # GPdraw=EigPhiEval$vectors%*%diag(sapply(EigPhiEval$values,function(xx){
  #   max(c(xx,0))
  # }))%*%matrix(rnorm(n=dim(PhiEval)[1])) + rnorm(n=dim(PhiEval)[1])  * sqrt(sigma^2/(72/n1))
  
  GPdraw1 = rmvnorm(n=1,sigma = PhiEval)
  GPdraw = GPdraw1 + rnorm(n=dim(PhiEval)[1])  * sqrt(sigmaX^2/(tN/n1))
  
  fHatNom=PhiEval[(n1+1):(n1+100),1:n1]%*%solve(PhiEval[1:n1,1:n1] + sigma^2/(72/n1) * diag(n1),GPdraw[1:n1])
  
  a1 = max((fHatNom-GPdraw1[(n1+1):(n1+100)])^2)
  
  print("4a1")
  
  PhiEvalg=phi(myDistoptLHS)
  EigPhiEval=eigen(PhiEvalg)
  
  PhiEval=phi(myDistoptLHS) 
  
  # GPdraw=EigPhiEval$vectors%*%diag(sapply(EigPhiEval$values,function(xx){
  #   max(c(xx,0))
  # }))%*%matrix(rnorm(n=dim(PhiEval)[1])) + rnorm(n=dim(PhiEval)[1])  * sqrt(sigma^2/(72/n1))
  
  GPdraw1 = rmvnorm(n=1,sigma = PhiEval)
  GPdraw = GPdraw1 + rnorm(n=dim(PhiEval)[1])  * sqrt(sigmaX^2/(tN/n1))
  
  fHatopt=PhiEval[(n1+1):(n1+100),1:n1]%*%solve(PhiEval[1:n1,1:n1] + sigma^2/(72/n1) * diag(n1),GPdraw[1:n1])
  
  a2 = max((fHatopt-GPdraw1[(n1+1):(n1+100)])^2)
  
  print("4a2")
  
  PhiEvalg=phi(myDistrandLHS)
  EigPhiEval=eigen(PhiEvalg)
  
  PhiEval=phi(myDistrandLHS) 
  
  # GPdraw=EigPhiEval$vectors%*%diag(sapply(EigPhiEval$values,function(xx){
  #   max(c(xx,0))
  # }))%*%matrix(rnorm(n=dim(PhiEval)[1])) + rnorm(n=dim(PhiEval)[1])  * sqrt(sigma^2/(72/n1))
  
  GPdraw1 = rmvnorm(n=1,sigma = PhiEval)
  GPdraw = GPdraw1 + rnorm(n=dim(PhiEval)[1])  * sqrt(sigmaX^2/(tN/n1))
  
  fHatrand=PhiEval[(n1+1):(n1+100),1:n1]%*%solve(PhiEval[1:n1,1:n1] + sigma^2/(72/n1) * diag(n1),GPdraw[1:n1])
  
  a3 = max((fHatrand-GPdraw1[(n1+1):(n1+100)])^2)
  
  print("4a3")
  
  PhiEvalg=phi(myDistrand)
  EigPhiEval=eigen(PhiEvalg)
  
  PhiEval=phi(myDistrand) 
  
  # GPdraw=EigPhiEval$vectors%*%diag(sapply(EigPhiEval$values,function(xx){
  #   max(c(xx,0))
  # }))%*%matrix(rnorm(n=dim(PhiEval)[1])) + rnorm(n=dim(PhiEval)[1])  * sqrt(sigma^2/(72/n1))
  
  GPdraw1 = rmvnorm(n=1,sigma = PhiEval)
  GPdraw = GPdraw1 + rnorm(n=dim(PhiEval)[1])  * sqrt(sigmaX^2/(tN/n1))
  
  fHatMC=PhiEval[(n1+1):(n1+100),1:n1]%*%solve(PhiEval[1:n1,1:n1] + sigma^2/(72/n1) * diag(n1),GPdraw[1:n1])
  
  a4 = max((fHatMC-GPdraw1[(n1+1):(n1+100)])^2)
  
  
  
  print("4a4")
  
  PhiEvalg=phi(myDistmaxpro)
  EigPhiEval=eigen(PhiEvalg)
  
  PhiEval=phi(myDistmaxpro)
  
  # GPdraw=EigPhiEval$vectors%*%diag(sapply(EigPhiEval$values,function(xx){
  #   max(c(xx,0))
  # }))%*%matrix(rnorm(n=dim(PhiEval)[1])) + rnorm(n=dim(PhiEval)[1])  * sqrt(sigma^2/(72/n1))
  
  GPdraw1 = rmvnorm(n=1,sigma = PhiEval)
  GPdraw = GPdraw1 + rnorm(n=dim(PhiEval)[1])  * sqrt(sigmaX^2/(tN/n1))
  
  fHatmaxpro=PhiEval[(n1+1):(n1+100),1:n1]%*%solve(PhiEval[1:n1,1:n1] + sigma^2/(72/n1) * diag(n1),GPdraw[1:n1])
  
  a5 = max((fHatmaxpro-GPdraw1[(n1+1):(n1+100)])^2)
  
  print("4a5")
  
  mspes72 = rbind(mspes72,c(a1,a2,a3,a4,a5))
  
  print(iter)
  
}

apply(mspes18,2,mean)[c(1,2,3,4,5)]
apply(mspes24,2,mean)[c(1,2,3,4,5)]
apply(mspes36,2,mean)[c(1,2,3,4,5)]
apply(mspes72,2,mean)[c(1,2,3,4,5)]

save.image(file = "comparisonImage_0_25.RData")
