load("C:/Users/wangw/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/varianceChange/Stationary18points.RData")
XstationaryNominal18=matrix(Result[[2]],ncol=2)
load("C:/Users/wangw/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/varianceChange/Stationary24points.RData")
XstationaryNominal24=matrix(Result[[2]],ncol=2)
load("C:/Users/wangw/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/varianceChange/Stationary36points.RData")
XstationaryNominal36=matrix(Result[[2]],ncol=2)
load("C:/Users/wangw/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/varianceChange/Stationary72points.RData")
XstationaryNominal72=matrix(Result[[2]],ncol=2)

load("C:/Users/wangw/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/varianceChange/numeric18points.RData")
XstationaryNumeric18=matrix(Result[[2]],ncol=2)
load("C:/Users/wangw/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/varianceChange/numeric24points.RData")
XstationaryNumeric24 = myX
load("C:/Users/wangw/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/varianceChange/numeric36points.RData")
XstationaryNumeric36 = matrix(Result[[2]],ncol=2)
load("C:/Users/wangw/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/varianceChange/numeric72points.RData")
XstationaryNumeric72 = myX

load("C:/Users/wangw/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/varianceChange/Final_Result18nonPa.RData")
Xpara18=matrix(Result[[2]],ncol=2)
load("C:/Users/wangw/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/varianceChange/Final_Result24nonPa.RData")
Xpara24=matrix(Result[[2]],ncol=2)
load("C:/Users/wangw/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/varianceChange/Final_Result36nonPa.RData")
Xpara36=matrix(Result[[2]],ncol=2)
load("C:/Users/wangw/Dropbox/gatech/research/BenHaaland/stochasticKriging/Rcode/varianceChange/Final_Result72nonPa.RData")
Xpara72=matrix(Result[[2]],ncol=2)



library(mlegp)
library(lhs)
library(mvtnorm)
library(MaxPro)



phi = function(dists){
  return(exp(-dists^2))
}

mspes18=matrix(NA,0,7)
mspes24=matrix(NA,0,7)
mspes36=matrix(NA,0,7)
mspes72=matrix(NA,0,7)

N=72

#Nt = c( 1,1,3,5,1,2,4,2,3,4,6,3,4,6,5,6,7,9)
Nt = 4

mysigXNominal18 = rowSums(XstationaryNominal18^2)/Nt + 0.04

#Nt = c(1,1,3,3,1,1,2,3,1,2,3,5,2,2,3,4,3,3,4,6,3,4,5,7)
Nt = 3
mysigXNominal24 = rowSums(XstationaryNominal24^2)/Nt + 0.04

#Nt = c(1,1,1,1,2,2,1,1,1,1,2,2,1,1,2,2,2,3,2,1,2,2,2,3,2,2,2,2,3,4,2,2,2,3,4,5)
Nt = 2
mysigXNominal36 = rowSums(XstationaryNominal36^2)/Nt + 0.04

mysigXNominal72 = rowSums(XstationaryNominal72^2) + 0.04


Nt = c(1,1,3,5,1,2,4,2,2,3,6,4,5,6,5,6,7,9)
Nt = 4
mysigXNumeric18 = rowSums(XstationaryNumeric18^2)/Nt + 0.04

Nt = c(1,1,3,4,1,1,2,3,1,2,2,4,2,2,2,4,3,3,4,6,4,5,5,7)
Nt = 3
mysigXNumeric24 = rowSums(XstationaryNumeric24^2)/Nt + 0.04

Nt = c(1,1,1,1,1,2,1,1,1,1,1,2,1,1,1,2,2,3,2,2,2,2,2,3,2,3,3,3,3,4,2,2,3,3,3,4)
Nt = 2
mysigXNumeric36 = rowSums(XstationaryNumeric36^2)/Nt + 0.04

mysigXNumeric72 = rowSums(XstationaryNumeric72^2) + 0.04

Nt = c(1,1,4,4,1,2,5,2,2,4,6,4,4,7,4,5,7,9)
Nt = 4
mysigXPara18 = rowSums(Xpara18^2)/Nt + 0.04

Nt = c(1,1,2,4,1,1,2,3,1,2,3,4,2,2,3,5,3,3,4,6,3,4,6,6)
Nt = 3
mysigXPara24 = rowSums(Xpara24^2)/Nt + 0.04

Nt = c(1,1,1,2,2,3,1,1,1,1,2,3,1,1,1,2,2,3,2,2,2,2,2,3,3,3,3,3,3,4,3,3,3,4,3,5)
Nt = 2
mysigXPara36 = rowSums(Xpara36^2)/Nt + 0.04

mysigXPara72 = rowSums(Xpara72^2) + 0.04

# Nt = floor(N * rowSums(XstationaryNominal18^2)/sum(XstationaryNominal18^2)) + 1
# 
# mysigXNominal18 = rowSums(XstationaryNominal18^2)/Nt + 0.04
# mysigXNominal24 = rowSums(XstationaryNominal24^2)/(floor(N * rowSums(XstationaryNominal24^2)/sum(XstationaryNominal24^2)) + 1) + 0.04
# mysigXNominal36 = rowSums(XstationaryNominal36^2)/(floor(N * rowSums(XstationaryNominal36^2)/sum(XstationaryNominal36^2)) + 1) + 0.04
# mysigXNominal72 = rowSums(XstationaryNominal72^2) + 0.04
# 
# mysigXNumeric18 = rowSums(XstationaryNumeric18^2)/(floor(N * rowSums(XstationaryNumeric18^2)/sum(XstationaryNumeric18^2)) + 1) + 0.04
# mysigXNumeric24 = rowSums(XstationaryNumeric24^2)/(floor(N * rowSums(XstationaryNumeric24^2)/sum(XstationaryNumeric24^2)) + 1) + 0.04
# mysigXNumeric36 = rowSums(XstationaryNumeric36^2)/(floor(N * rowSums(XstationaryNumeric36^2)/sum(XstationaryNumeric36^2)) + 1) + 0.04
# mysigXNumeric72 = rowSums(XstationaryNumeric72^2) + 0.04
# 
# mysigXPara18 = rowSums(Xpara18^2)/(floor(N * rowSums(Xpara18^2)/sum(Xpara18^2)) + 1) + 0.04
# mysigXPara24 = rowSums(Xpara24^2)/(floor(N * rowSums(Xpara24^2)/sum(Xpara24^2)) + 1) + 0.04
# mysigXPara36 = rowSums(Xpara36^2)/(floor(N * rowSums(Xpara36^2)/sum(Xpara36^2)) + 1) + 0.04
# mysigXPara72 = rowSums(Xpara72^2) + 0.04

for(iter in 1:300){
  #maximinLHS(23,2)
  optLHS18=optimumLHS(18,2)
  optLHS24=optimumLHS(24,2)
  optLHS36=optimumLHS(36,2)
  optLHS72=optimumLHS(72,2)
  
  randLHS18=randomLHS(18,2)
  randLHS24=randomLHS(24,2)
  randLHS36=randomLHS(36,2)
  randLHS72=randomLHS(72,2)
  
  rand18=matrix(runif(18*2),ncol=2)
  rand24=matrix(runif(24*2),ncol=2)
  rand36=matrix(runif(36*2),ncol=2)
  rand72=matrix(runif(72*2),ncol=2)
  
  InitialDesign<-MaxProLHD(n = 18, p = 2)$Design
  DOX<-MaxPro(InitialDesign)
  maxpro18=DOX$Design
  InitialDesign<-MaxProLHD(n = 24, p = 2)$Design
  DOX<-MaxPro(InitialDesign)
  maxpro24=DOX$Design
  InitialDesign<-MaxProLHD(n = 36, p = 2)$Design
  DOX<-MaxPro(InitialDesign)
  maxpro36=DOX$Design
  InitialDesign<-MaxProLHD(n = 72, p = 2)$Design
  DOX<-MaxPro(InitialDesign)
  maxpro72=DOX$Design
  
  testSet=matrix(runif(100*2),ncol=2)
  
  mypoint18 = rbind(XstationaryNominal18,XstationaryNumeric18,Xpara18,optLHS18,randLHS18,rand18,maxpro18,testSet)
  mypoint24 = rbind(XstationaryNominal24,XstationaryNumeric24,Xpara24,optLHS24,randLHS24,rand24,maxpro24,testSet)
  mypoint36 = rbind(XstationaryNominal36,XstationaryNumeric36,Xpara36,optLHS36,randLHS36,rand36,maxpro36,testSet)
  mypoint72 = rbind(XstationaryNominal72,XstationaryNumeric72,Xpara72,optLHS72,randLHS72,rand72,maxpro72,testSet)
  
  myDist18=as.matrix(dist(mypoint18,diag=TRUE,upper=TRUE))
  PhiEval18=phi(myDist18)
  myDist24=as.matrix(dist(mypoint24,diag=TRUE,upper=TRUE))
  PhiEval24=phi(myDist24)
  myDist36=as.matrix(dist(mypoint36,diag=TRUE,upper=TRUE))
  PhiEval36=phi(myDist36)
  myDist72=as.matrix(dist(mypoint72,diag=TRUE,upper=TRUE))
  PhiEval72=phi(myDist72)
  
  # mysigoptLHS18 = rowSums(optLHS18^2)/(floor(N * rowSums(optLHS18^2)/sum(optLHS18^2)) + 1) + 0.04
  # mysigoptLHS24 = rowSums(optLHS24^2)/(floor(N * rowSums(optLHS24^2)/sum(optLHS24^2)) + 1) + 0.04
  # mysigoptLHS36 = rowSums(optLHS36^2)/(floor(N * rowSums(optLHS36^2)/sum(optLHS36^2)) + 1) + 0.04
  # mysigoptLHS72 = rowSums(optLHS72^2) + 0.04
  # 
  # mysigrandLHS18 = rowSums(randLHS18^2)/(floor(N * rowSums(randLHS18^2)/sum(randLHS18^2)) + 1) + 0.04
  # mysigrandLHS24 = rowSums(randLHS24^2)/(floor(N * rowSums(randLHS24^2)/sum(randLHS24^2)) + 1) + 0.04
  # mysigrandLHS36 = rowSums(randLHS36^2)/(floor(N * rowSums(randLHS36^2)/sum(randLHS36^2)) + 1) + 0.04
  # mysigrandLHS72 = rowSums(randLHS72^2) + 0.04
  # 
  # mysigrand18 = rowSums(rand18^2)/(floor(N * rowSums(rand18^2)/sum(rand18^2)) + 1) + 0.04
  # mysigrand24 = rowSums(rand24^2)/(floor(N * rowSums(rand24^2)/sum(rand24^2)) + 1) + 0.04
  # mysigrand36 = rowSums(rand36^2)/(floor(N * rowSums(rand36^2)/sum(rand36^2)) + 1) + 0.04
  # mysigrand72 = rowSums(rand72^2) + 0.04
  # 
  # mysigmaxpro18 = rowSums(maxpro18^2)/(floor(N * rowSums(maxpro18^2)/sum(maxpro18^2)) + 1) + 0.04
  # mysigmaxpro24 = rowSums(maxpro24^2)/(floor(N * rowSums(maxpro24^2)/sum(maxpro24^2)) + 1) + 0.04
  # mysigmaxpro36 = rowSums(maxpro36^2)/(floor(N * rowSums(maxpro36^2)/sum(maxpro36^2)) + 1) + 0.04
  # mysigmaxpro72 = rowSums(maxpro72^2) + 0.04
  
  mysigoptLHS18 = rowSums(optLHS18^2)/4+ 0.04
  mysigoptLHS24 = rowSums(optLHS24^2)/3 + 0.04
  mysigoptLHS36 = rowSums(optLHS36^2)/2 + 0.04
  mysigoptLHS72 = rowSums(optLHS72^2) + 0.04
  
  mysigrandLHS18 = rowSums(randLHS18^2)/4 + 0.04
  mysigrandLHS24 = rowSums(randLHS24^2)/3 + 0.04
  mysigrandLHS36 = rowSums(randLHS36^2)/2 + 0.04
  mysigrandLHS72 = rowSums(randLHS72^2) + 0.04
  
  mysigrand18 = rowSums(rand18^2)/4 + 0.04
  mysigrand24 = rowSums(rand24^2)/3 + 0.04
  mysigrand36 = rowSums(rand36^2)/2 + 0.04
  mysigrand72 = rowSums(rand72^2) + 0.04
  
  mysigmaxpro18 = rowSums(maxpro18^2)/4 + 0.04
  mysigmaxpro24 = rowSums(maxpro24^2)/3 + 0.04
  mysigmaxpro36 = rowSums(maxpro36^2)/2 + 0.04
  mysigmaxpro72 = rowSums(maxpro72^2) + 0.04
  
  mysigtestSet = rowSums(testSet^2) + 0.04
  
  ttttt = 1
  
  mysigmaDiag18 = ttttt * diag(c(mysigXNominal18,mysigXNumeric18,mysigXPara18, mysigoptLHS18,mysigrandLHS18,
                         mysigrand18,mysigmaxpro18,mysigtestSet))
  mysigmaDiag24 = ttttt * diag(c(mysigXNominal24,mysigXNumeric24,mysigXPara24, mysigoptLHS24,mysigrandLHS24,
                         mysigrand24,mysigmaxpro24,mysigtestSet))
  mysigmaDiag36 = ttttt * diag(c(mysigXNominal36,mysigXNumeric36,mysigXPara36, mysigoptLHS36,mysigrandLHS36,
                         mysigrand36,mysigmaxpro36,mysigtestSet))
  mysigmaDiag72 = ttttt * diag(c(mysigXNominal72,mysigXNumeric72,mysigXPara72, mysigoptLHS72,mysigrandLHS72,
                         mysigrand72,mysigmaxpro72,mysigtestSet))
  
  ####################################18################################
  
  tt = 18
  
  GPdraw118 = rmvnorm(n=1 ,sigma = PhiEval18)
  GPdraw18 = GPdraw118 + t(rnorm(n=dim(PhiEval18)[1]))%*% mysigmaDiag18
  
  fHatNom18=PhiEval18[(7*tt + 1):(7*tt + 100),1:tt]%*%solve(PhiEval18[1:tt,1:tt] + mysigmaDiag18[1:tt,1:tt],GPdraw18[1:tt])
  fHatNum18=PhiEval18[(7*tt + 1):(7*tt + 100),(tt + 1):(2 * tt)]%*%solve(PhiEval18[(tt + 1):(2 * tt),(tt + 1):(2 * tt)]
                                             + mysigmaDiag18[(tt + 1):(2 * tt),(tt + 1):(2 * tt)],GPdraw18[(tt + 1):(2 * tt)])
  fHatParaEst18=PhiEval18[(7*tt + 1):(7*tt + 100),(2 * tt + 1):(3 * tt)]%*%solve(PhiEval18[(2 * tt + 1):(3 * tt),(2 * tt + 1):(3 * tt)] 
                                             + mysigmaDiag18[(2 * tt + 1):(3 * tt),(2 * tt + 1):(3 * tt)],GPdraw18[(2 * tt + 1):(3 * tt)])
  
  fHatopt18=PhiEval18[(7*tt + 1):(7*tt + 100),(3 * tt + 1):(4 * tt)]%*%solve(PhiEval18[(3 * tt + 1):(4 * tt),(3 * tt + 1):(4 * tt)] 
                                             + mysigmaDiag18[(3 * tt + 1):(4 * tt),(3 * tt + 1):(4 * tt)] ,GPdraw18[(3 * tt + 1):(4 * tt)])
  fHatrand18=PhiEval18[(7*tt + 1):(7*tt + 100),(4 * tt + 1):(5 * tt)]%*%solve(PhiEval18[(4 * tt + 1):(5 * tt),(4 * tt + 1):(5 * tt)]
                                             + mysigmaDiag18[(4 * tt + 1):(5 * tt),(4 * tt + 1):(5 * tt)],GPdraw18[(4 * tt + 1):(5 * tt)])
  fHatMC18=PhiEval18[(7*tt + 1):(7*tt + 100),(5 * tt + 1):(6 * tt)]%*%solve(PhiEval18[(5 * tt + 1):(6 * tt),(5 * tt + 1):(6 * tt)]
                                             + mysigmaDiag18[(5 * tt + 1):(6 * tt),(5 * tt + 1):(6 * tt)],GPdraw18[(5 * tt + 1):(6 * tt)])
  fHatmaxpro18=PhiEval18[(7*tt + 1):(7*tt + 100),(6 * tt + 1):(7 * tt)]%*%solve(PhiEval18[(6 * tt + 1):(7 * tt),(6 * tt + 1):(7 * tt)]
                                             + mysigmaDiag18[(6 * tt + 1):(7 * tt),(6 * tt + 1):(7 * tt)],GPdraw18[(6 * tt + 1):(7 * tt)])
  
  mspes18=rbind(mspes18,
              c(max((fHatNom18-GPdraw118[(7*tt + 1):(7*tt + 100)])^2),
                max((fHatNum18-GPdraw118[(7*tt + 1):(7*tt + 100)])^2),
                max((fHatParaEst18-GPdraw118[(7*tt + 1):(7*tt + 100)])^2),
                max((fHatopt18-GPdraw118[(7*tt + 1):(7*tt + 100)])^2),
                max((fHatrand18-GPdraw118[(7*tt + 1):(7*tt + 100)])^2),
                max((fHatMC18-GPdraw118[(7*tt + 1):(7*tt + 100)])^2),
                max((fHatmaxpro18-GPdraw118[(7*tt + 1):(7*tt + 100)])^2)))
  
  ####################################24################################
  
  tt = 24
  
  GPdraw124 = rmvnorm(n=1 ,sigma = PhiEval24)
  GPdraw24 = GPdraw124 + t(rnorm(n=dim(PhiEval24)[1]))%*% mysigmaDiag24
  
  fHatNom24=PhiEval24[(7*tt + 1):(7*tt + 100),1:tt]%*%solve(PhiEval24[1:tt,1:tt] + mysigmaDiag24[1:tt,1:tt],GPdraw24[1:tt])
  fHatNum24=PhiEval24[(7*tt + 1):(7*tt + 100),(tt + 1):(2 * tt)]%*%solve(PhiEval24[(tt + 1):(2 * tt),(tt + 1):(2 * tt)]
                                                                         + mysigmaDiag24[(tt + 1):(2 * tt),(tt + 1):(2 * tt)],GPdraw24[(tt + 1):(2 * tt)])
  fHatParaEst24=PhiEval24[(7*tt + 1):(7*tt + 100),(2 * tt + 1):(3 * tt)]%*%solve(PhiEval24[(2 * tt + 1):(3 * tt),(2 * tt + 1):(3 * tt)] 
                                                                                 + mysigmaDiag24[(2 * tt + 1):(3 * tt),(2 * tt + 1):(3 * tt)],GPdraw24[(2 * tt + 1):(3 * tt)])
  
  fHatopt24=PhiEval24[(7*tt + 1):(7*tt + 100),(3 * tt + 1):(4 * tt)]%*%solve(PhiEval24[(3 * tt + 1):(4 * tt),(3 * tt + 1):(4 * tt)] 
                                                                             + mysigmaDiag24[(3 * tt + 1):(4 * tt),(3 * tt + 1):(4 * tt)] ,GPdraw24[(3 * tt + 1):(4 * tt)])
  fHatrand24=PhiEval24[(7*tt + 1):(7*tt + 100),(4 * tt + 1):(5 * tt)]%*%solve(PhiEval24[(4 * tt + 1):(5 * tt),(4 * tt + 1):(5 * tt)]
                                                                              + mysigmaDiag24[(4 * tt + 1):(5 * tt),(4 * tt + 1):(5 * tt)],GPdraw24[(4 * tt + 1):(5 * tt)])
  fHatMC24=PhiEval24[(7*tt + 1):(7*tt + 100),(5 * tt + 1):(6 * tt)]%*%solve(PhiEval24[(5 * tt + 1):(6 * tt),(5 * tt + 1):(6 * tt)]
                                                                            + mysigmaDiag24[(5 * tt + 1):(6 * tt),(5 * tt + 1):(6 * tt)],GPdraw24[(5 * tt + 1):(6 * tt)])
  fHatmaxpro24=PhiEval24[(7*tt + 1):(7*tt + 100),(6 * tt + 1):(7 * tt)]%*%solve(PhiEval24[(6 * tt + 1):(7 * tt),(6 * tt + 1):(7 * tt)]
                                                                                + mysigmaDiag24[(6 * tt + 1):(7 * tt),(6 * tt + 1):(7 * tt)],GPdraw24[(6 * tt + 1):(7 * tt)])
  
  mspes24=rbind(mspes24,
                c(max((fHatNom24-GPdraw124[(7*tt + 1):(7*tt + 100)])^2),
                  max((fHatNum24-GPdraw124[(7*tt + 1):(7*tt + 100)])^2),
                  max((fHatParaEst24-GPdraw124[(7*tt + 1):(7*tt + 100)])^2),
                  max((fHatopt24-GPdraw124[(7*tt + 1):(7*tt + 100)])^2),
                  max((fHatrand24-GPdraw124[(7*tt + 1):(7*tt + 100)])^2),
                  max((fHatMC24-GPdraw124[(7*tt + 1):(7*tt + 100)])^2),
                  max((fHatmaxpro24-GPdraw124[(7*tt + 1):(7*tt + 100)])^2)))
  
  ####################################36################################

  
  tt = 36
  
  GPdraw136 = rmvnorm(n=1 ,sigma = PhiEval36)
  GPdraw36 = GPdraw136 + t(rnorm(n=dim(PhiEval36)[1]))%*% mysigmaDiag36
  
  fHatNom36=PhiEval36[(7*tt + 1):(7*tt + 100),1:tt]%*%solve(PhiEval36[1:tt,1:tt] + mysigmaDiag36[1:tt,1:tt],GPdraw36[1:tt])
  fHatNum36=PhiEval36[(7*tt + 1):(7*tt + 100),(tt + 1):(2 * tt)]%*%solve(PhiEval36[(tt + 1):(2 * tt),(tt + 1):(2 * tt)]
                                                                         + mysigmaDiag36[(tt + 1):(2 * tt),(tt + 1):(2 * tt)],GPdraw36[(tt + 1):(2 * tt)])
  fHatParaEst36=PhiEval36[(7*tt + 1):(7*tt + 100),(2 * tt + 1):(3 * tt)]%*%solve(PhiEval36[(2 * tt + 1):(3 * tt),(2 * tt + 1):(3 * tt)] 
                                                                                 + mysigmaDiag36[(2 * tt + 1):(3 * tt),(2 * tt + 1):(3 * tt)],GPdraw36[(2 * tt + 1):(3 * tt)])
  
  fHatopt36=PhiEval36[(7*tt + 1):(7*tt + 100),(3 * tt + 1):(4 * tt)]%*%solve(PhiEval36[(3 * tt + 1):(4 * tt),(3 * tt + 1):(4 * tt)] 
                                                                             + mysigmaDiag36[(3 * tt + 1):(4 * tt),(3 * tt + 1):(4 * tt)] ,GPdraw36[(3 * tt + 1):(4 * tt)])
  fHatrand36=PhiEval36[(7*tt + 1):(7*tt + 100),(4 * tt + 1):(5 * tt)]%*%solve(PhiEval36[(4 * tt + 1):(5 * tt),(4 * tt + 1):(5 * tt)]
                                                                              + mysigmaDiag36[(4 * tt + 1):(5 * tt),(4 * tt + 1):(5 * tt)],GPdraw36[(4 * tt + 1):(5 * tt)])
  fHatMC36=PhiEval36[(7*tt + 1):(7*tt + 100),(5 * tt + 1):(6 * tt)]%*%solve(PhiEval36[(5 * tt + 1):(6 * tt),(5 * tt + 1):(6 * tt)]
                                                                            + mysigmaDiag36[(5 * tt + 1):(6 * tt),(5 * tt + 1):(6 * tt)],GPdraw36[(5 * tt + 1):(6 * tt)])
  fHatmaxpro36=PhiEval36[(7*tt + 1):(7*tt + 100),(6 * tt + 1):(7 * tt)]%*%solve(PhiEval36[(6 * tt + 1):(7 * tt),(6 * tt + 1):(7 * tt)]
                                                                                + mysigmaDiag36[(6 * tt + 1):(7 * tt),(6 * tt + 1):(7 * tt)],GPdraw36[(6 * tt + 1):(7 * tt)])
  
  mspes36=rbind(mspes36,
                c(max((fHatNom36-GPdraw136[(7*tt + 1):(7*tt + 100)])^2),
                  max((fHatNum36-GPdraw136[(7*tt + 1):(7*tt + 100)])^2),
                  max((fHatParaEst36-GPdraw136[(7*tt + 1):(7*tt + 100)])^2),
                  max((fHatopt36-GPdraw136[(7*tt + 1):(7*tt + 100)])^2),
                  max((fHatrand36-GPdraw136[(7*tt + 1):(7*tt + 100)])^2),
                  max((fHatMC36-GPdraw136[(7*tt + 1):(7*tt + 100)])^2),
                  max((fHatmaxpro36-GPdraw136[(7*tt + 1):(7*tt + 100)])^2)))
  
  ####################################72################################
  
  tt = 72
  
  GPdraw172 = rmvnorm(n=1 ,sigma = PhiEval72)
  GPdraw72 = GPdraw172 + t(rnorm(n=dim(PhiEval72)[1]))%*% mysigmaDiag72
  
  fHatNom72=PhiEval72[(7*tt + 1):(7*tt + 100),1:tt]%*%solve(PhiEval72[1:tt,1:tt] + mysigmaDiag72[1:tt,1:tt],GPdraw72[1:tt])
  fHatNum72=PhiEval72[(7*tt + 1):(7*tt + 100),(tt + 1):(2 * tt)]%*%solve(PhiEval72[(tt + 1):(2 * tt),(tt + 1):(2 * tt)]
                                                                         + mysigmaDiag72[(tt + 1):(2 * tt),(tt + 1):(2 * tt)],GPdraw72[(tt + 1):(2 * tt)])
  fHatParaEst72=PhiEval72[(7*tt + 1):(7*tt + 100),(2 * tt + 1):(3 * tt)]%*%solve(PhiEval72[(2 * tt + 1):(3 * tt),(2 * tt + 1):(3 * tt)] 
                                                                                 + mysigmaDiag72[(2 * tt + 1):(3 * tt),(2 * tt + 1):(3 * tt)],GPdraw72[(2 * tt + 1):(3 * tt)])
  
  fHatopt72=PhiEval72[(7*tt + 1):(7*tt + 100),(3 * tt + 1):(4 * tt)]%*%solve(PhiEval72[(3 * tt + 1):(4 * tt),(3 * tt + 1):(4 * tt)] 
                                                                             + mysigmaDiag72[(3 * tt + 1):(4 * tt),(3 * tt + 1):(4 * tt)] ,GPdraw72[(3 * tt + 1):(4 * tt)])
  fHatrand72=PhiEval72[(7*tt + 1):(7*tt + 100),(4 * tt + 1):(5 * tt)]%*%solve(PhiEval72[(4 * tt + 1):(5 * tt),(4 * tt + 1):(5 * tt)]
                                                                              + mysigmaDiag72[(4 * tt + 1):(5 * tt),(4 * tt + 1):(5 * tt)],GPdraw72[(4 * tt + 1):(5 * tt)])
  fHatMC72=PhiEval72[(7*tt + 1):(7*tt + 100),(5 * tt + 1):(6 * tt)]%*%solve(PhiEval72[(5 * tt + 1):(6 * tt),(5 * tt + 1):(6 * tt)]
                                                                            + mysigmaDiag72[(5 * tt + 1):(6 * tt),(5 * tt + 1):(6 * tt)],GPdraw72[(5 * tt + 1):(6 * tt)])
  fHatmaxpro72=PhiEval72[(7*tt + 1):(7*tt + 100),(6 * tt + 1):(7 * tt)]%*%solve(PhiEval72[(6 * tt + 1):(7 * tt),(6 * tt + 1):(7 * tt)]
                                                                                + mysigmaDiag72[(6 * tt + 1):(7 * tt),(6 * tt + 1):(7 * tt)],GPdraw72[(6 * tt + 1):(7 * tt)])
  
  mspes72=rbind(mspes72,
                c(max((fHatNom72-GPdraw172[(7*tt + 1):(7*tt + 100)])^2),
                  max((fHatNum72-GPdraw172[(7*tt + 1):(7*tt + 100)])^2),
                  max((fHatParaEst72-GPdraw172[(7*tt + 1):(7*tt + 100)])^2),
                  max((fHatopt72-GPdraw172[(7*tt + 1):(7*tt + 100)])^2),
                  max((fHatrand72-GPdraw172[(7*tt + 1):(7*tt + 100)])^2),
                  max((fHatMC72-GPdraw172[(7*tt + 1):(7*tt + 100)])^2),
                  max((fHatmaxpro72-GPdraw172[(7*tt + 1):(7*tt + 100)])^2)))
  
  # print(c(iter,apply(mspes18,2,mean)[c(1,2,3,4,5,6,7)],
  #              apply(mspes24,2,mean)[c(1,2,3,4,5,6,7)],
  #              apply(mspes36,2,mean)[c(1,2,3,4,5,6,7)],
  #              apply(mspes72,2,mean)[c(1,2,3,4,5,6,7)]))
  
  print(iter)
  
  
}

A18 = apply(mspes18,2,mean)[c(1,2,3,4,5,6,7)]
A24 = apply(mspes24,2,mean)[c(1,2,3,4,5,6,7)]
A36 = apply(mspes36,2,mean)[c(1,2,3,4,5,6,7)]
A72 = apply(mspes72,2,mean)[c(1,2,3,4,5,6,7)]
save.image(file = "comparisonALL_PARAEST.RData")




temp = deldir(x=myX[,1],y=myX[,2],rw=c(0,1,0,1),plotit=FALSE)
par(mai = c(0.8,0.5,0.5,0.5))
plot.deldir(temp, wlines='tess', xlab = NA, ylab = NA, wpoints = 'none')
box(which = "plot")
text(myX[,1], myX[,2], c(1,1,3,3,1,1,2,3,1,2,3,5,2,2,3,4,3,3,4,6,3,4,5,7) )
